/**
 * Copyright (c) 2013-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.cli.extension.command.monitoring.so;

import org.ow2.petals.jmx.api.api.monitoring.Defect;
import org.ow2.petals.jmx.api.api.monitoring.DefectListener;

public class DefectEchoer implements DefectListener {

    public final static short NAGIOS_CRITICAL = 2;

    public final static String NAGIOS_COMMAND = "PROCESS_SERVICE_CHECK_RESULT";

    private final NagiosMapper mapper;

    public DefectEchoer(final NagiosMapper mapper) {
        this.mapper = mapper;
    }

    @Override
    public void onDefect(final Defect defect) {
        final StringBuilder strBuilder = new StringBuilder();

        strBuilder.append('[');
        // Nagios requires an Epoch time in seconds since 01/01/1970
        strBuilder.append(defect.getTimestamp() / 1000L);
        strBuilder.append(']');
        strBuilder.append(' ');
        strBuilder.append(NAGIOS_COMMAND);
        strBuilder.append(';');
        strBuilder.append(this.mapper.getNagiosHost(defect.getEmitter()));
        strBuilder.append(';');
        strBuilder.append(this.mapper.getNagiosService(defect.getType()));
        strBuilder.append(';');
        strBuilder.append(NAGIOS_CRITICAL);
        strBuilder.append(';');
        strBuilder.append(defect.getMessage());

        System.out.println(strBuilder.toString());
    }
}
